//+----------------------------------------------------------------------------------------+
//|                                                                                        
//| original dlls for digital filters
//| made by Sergey Iljukhin, Novosibirsk
//| 
//| notice :
//| in order to work properly following 4 dlls must be present in windows\system32
//|      bdsp.dll, lapack.dll, mkl_support.dll and df.dll
//|
//|
//|  parameters description :
//|  
//|  Ftype -  : 0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 
//|          2 -  (RBCI/KGBP), 3 -  (KGBS)
//|  P1 -      P1, 
//|  D1 -        D1, 
//|  A1 -        1, 
//|  P2 -      P2, 
//|  D2 -        D2, 
//|  A2 -        2, 
//|  Ripple -    , 
//|  Delay - , 
//|
//|        P2,D2,A2 
//|   :
//|  : P1>D1
//|  : P1<D1
//|    : D2>P2>P1>D1
//|
//+----------------------------------------------------------------------------------------+

#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

#import "df.dll"
   int DigitalFilter(int FType, int P1, int D1, int A1, int P2, int D2, int A2, double Ripple, int Delay, double& arr[]); 
#import

//
//
//
//
//

extern int    Price         = PRICE_CLOSE;
extern int    FilterType    =  0;  // : 0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 2 -  (RBCI/KGBP), 3 -  (KGBS)
extern int    FilterSubType =  0;
extern int    P1            = 28;  //  P1, 
extern int    D1            = 19;  //    D1, 
extern int    A1            = 40;  //    1, 
extern int    P2            =  0;  //  P2, 
extern int    D2            =  0;  //    D2, 
extern int    A2            =  0;  //    2, 
extern int    Delay         =  0;  //, 
extern double Ripple        = 0.08;//   ,  

//
//
//
//
//

double values[];
double valuesDa[];
double valuesDb[];
double prices[];
double trend[];
double Filter[1500];
int    FilterSize;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------  
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, values);
   SetIndexBuffer(1, valuesDa);
   SetIndexBuffer(2, valuesDb);
   SetIndexBuffer(3, trend);
   SetIndexBuffer(4, prices);

   //
   //
   //
   //
   //

   switch(FilterSubType)
   {
      case 1: P1=14; D1=10; A1=40; P2=0; D2=0; A2=0; Delay= 0; Ripple=0.08; break; // fatl
      case 2: P1=52; D1=32; A1=40; P2=0; D2=0; A2=0; Delay= 0; Ripple=0.08; break; // satl
      case 3: P1=14; D1=10; A1=40; P2=0; D2=0; A2=0; Delay= 5; Ripple=0.08; break; // rftl
      case 5: P1=52; D1=32; A1=40; P2=0; D2=0; A2=0; Delay=15; Ripple=0.08; break; // rstl
   }      

   //
   //
   //
   //
   //
   
   FilterSize=DigitalFilter(FilterType, P1, D1, A1, P2, D2, A2, Ripple, Delay, Filter);  
      if (FilterSize>0) ArrayResize(Filter,FilterSize+1);
      SetIndexDrawBegin(0, FilterSize+30);
   IndicatorDigits(Digits);
   return(0); 
} 


//+------------------------------------------------------------------+  
//|                                                                  | 
//+------------------------------------------------------------------+ 
//
//
//
//
//
 
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
         //
         //
         //
         //
         //
         
         bool canWork=true;
            if (FilterSize>=Bars) canWork = false;  
            if (FilterSize<1    ) canWork = false;
            if (canWork)
               switch (FilterType)
               {
                  case 0:   canWork = (P1>D1); break;
                  case 1:   canWork = (P1<D1); break;
               }
            if (!canWork) { Comment("parameters conditions not fulfilled"); return(0); }
            Comment("");

   //
   //
   //
   //
   //

   if (trend[limit] == -1) CleanPoint(limit,valuesDa,valuesDb);
   for(i=limit; i>=0; i--)
   {
      valuesDa[i] = EMPTY_VALUE;
      valuesDb[i] = EMPTY_VALUE;
      prices[i]   = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      values[i]   = 0;

         for(int k=0; k<=FilterSize; k++)  values[i] += Filter[k]*prices[i+k];
            trend[i] = trend[i+1];
               if (values[i]>values[i+1]) trend[i] =  1;
               if (values[i]<values[i+1]) trend[i] = -1;
               if (trend[i] == -1) PlotPoint(i,valuesDa,valuesDb,values);
   }
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}